Subject: Re: [PATCH iproute2 -next 2/2] tc: add eBPF support to f_bpf

From: Daniel Borkmann <[email-masked]>
Date: Mon, 16 Mar 2015 18:49:21 +0100

On 03/16/2015 06:45 PM, Alexei Starovoitov wrote:
> On 3/16/15 10:10 AM, Daniel Borkmann wrote:
>
>> +
>> +/* ELF section names, etc (ABI) */
>> +#define ELF_SECTION_LICENSE    "license"
>> +#define ELF_SECTION_MAPS    "maps"
>> +#define ELF_SECTION_CLASSIFIER    "classifier"
>> +#define ELF_SECTION_ACTION    "action"
>> +
>> +#define ELF_MAX_MAPS        64
>> +#define ELF_MAX_LICENSE_LEN    128
>> +
>> +/* ELF map definition (ABI) */
>> +struct bpf_elf_map {
>> +    __u32 type;
>> +    __u32 size_key;
>> +    __u32 size_value;
>> +    __u32 max_elem;
>> +};
>
> I think people might freak out that the above section names and
> the struct are a kernel ABI. It's obviously not.
> Would be good to say that this is a present convention between
> C program that describes tc classifier and tc elf reader
> and it can change in the future.

Ohh, well, it's not a kernel ABI. I actually don't intend to change
the section names either as we don't want to break tc users. I could
imagine aliases if truly necessary.

I guess, I'll elaborate on the comment, sure.